//+------------------------------------------------------------------+
//|                                                    1-quadrat.mq4 |
//|                                             Copyright  2008, AP |
//|                                                olgapob33@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, AP"
#property link      "olgapob33@mail.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Yellow

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#define max 3000

extern int N_Period=8;
extern int _Price=0;

double qWma[],qRma[],cena[];
double k,N;
double quad[max]; //1000 =  

int first=0;
int init()
  { int i; double sum;
  
//---- indicators
//----
    IndicatorBuffers(3);
   SetIndexBuffer(0,qWma);          
  SetIndexStyle(0,DRAW_LINE);   
  
  SetIndexBuffer(1,qRma);          
  SetIndexStyle(1,DRAW_LINE);
  
  SetIndexBuffer(2,cena);          
  SetIndexStyle(2,DRAW_NONE);
  
   if(_Price>6) _Price =6;
   if (N_Period>1000) N_Period=100;
   N=N_Period;
   //k=1./( N*(N+1)*(2*(N+1)) ); //*(N+1)
   sum=0;
   for(i=0;i<N_Period;i++)sum+=(N-i)*(N-i); 
   k=1./(sum-1);
   
   
   for(i=0;i<N_Period;i++) quad[i]=(N_Period-i)*(N_Period-i);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
/*
Quadratic Regression MA = 3 * SMA + QWMA * ( 10 - 15/( N + 2 ) ) - LWMA * ( 12 - 15/( N + 2 ) )

 N -  , 

QWMA( i; N ) = 6/( N*(N+1)(2*N+1) ) * sum( Close[i] * (N-i)^2; i = 0..N-1 ) (   ).
*/

int start()
  {int i,j,limit;
   int    counted_bars=IndicatorCounted();
   double sum;
   limit=max-counted_bars-1;
   for(i=0;i<limit;i++) 
   cena[i]=iMA(NULL,0,1,0,0,_Price,i);
   
int BT = GetTickCount();   
   
   for(i=0;i<limit;i++) 
      {
      sum=0;
      for (j=0;j<N_Period-1;j++) sum+=cena[i+j]*quad[j];
      qWma[i]=k*sum;
      }

   for(i=0;i<limit;i++)
   qRma[i]=3*iMA(NULL,0,N_Period,0,0,0,i) 
   + qWma[i]*(10.-15./(N+2))   
   - iMA(NULL,0,N_Period,0,MODE_LWMA,_Price,i)*(12.-15./(N+2));  
 
int ET = GetTickCount();   
Print(" iCustom:",ET-BT);
/*
qRma[i]=3*iMA(NULL,0,N_Period,0,0,0,i) 
   + qWma[i]
   - 3* iMA(NULL,0,N_Period,0,MODE_LWMA,_Price,i);
  
  */ 
   //    :
   /*
   qRma[i]=
   - 2.*qWma[i]
   + 3.* iMA(NULL,0,N_Period,0,MODE_LWMA,_Price,i); //2.99 -  k qWma
*/
   

//if(first==0) {first=1; Print (" QQQQ  ", i,"...",qWma[1],"...",qWma[2],"...",cena[1],"...",cena[2]);}






//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+